require 'nano/array/first'

class Array

  # Change the last element.
  #
  #   a = [1,2,5]
  #   a.last = 3
  #   p a           #=> [1,2,3]
  #
  def last=(x)
    self[-1] = x
  end

  # Alias for pop, which removes and returns
  # the last element in an array.
  #
  #   a = [1,2]
  #   a.last! 3
  #   p a           #=> [1,2,3]
  #
  alias_method( :last!, :pop)

end


#  _____         _
# |_   _|__  ___| |_
#   | |/ _ \/ __| __|
#   | |  __/\__ \ |_
#   |_|\___||___/\__|
#
=begin test

  require 'test/unit'

  class TCArray < Test::Unit::TestCase

    def test_last_eq
      a = [1,2]
      a.last = 3
      assert_equal( [1,3], a )
    end

    def test_last!
      a = [1,2,3]
      assert_equal( 3, a.last! )
      assert_equal( [1,2], a )
    end

  end

=end
